C     Copyright (C) 2004 B. Roukema et al. <shape-univ at astro.uni.torun.pl>
C     
C     This program is free software; you can redistribute it and/or modify
C     it under the terms of the GNU General Public License as published by
C     the Free Software Foundation; either version 2 of the License, or
C     (at your option) any later version.
C     
C     This program is distributed in the hope that it will be useful,
C     but WITHOUT ANY WARRANTY; without even the implied warranty of
C     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C     
C     You should have received a copy of the GNU General Public License
C     along with this program; if not, write to the Free Software
C     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C  
C     See also http://www.gnu.org/licenses/gpl.html

  
        real*4  function gauss(mean,sigma,seed)
c       chooses a number from a gaussian probability distribution
c       given randomising function  rnd(seed)

        integer*4 seed
        real*4    mean,sigma,p

        sigmax=4

        z=1.0
        p=0.0
        do 11 while(z.gt.p)
           x=rnd(seed)
           y=mean*1.0 + 2.0*(x-0.5)*sigma*sigmax
           z=rnd(seed)
           p=exp(-(y-mean)*(y-mean)/2.0/sigma/sigma)
11      continue
        gauss=y
        return
        end

        real*4  function gauss0(mean,sigma)
c       chooses a number from a gaussian probability distribution
c       based on randt()  which can be flushed if desired.

        real*4    mean,sigma,p
        sigmax=4

        z=1.0
        p=0.0
        do 11 while(z.gt.p)
c           x= randt()
           x= rnd(17)           ! dummy seed
           y=mean*1.0 + 2.0*(x-0.5)*sigma*sigmax
c           z=randt()
           z=rnd(17)            ! dummy seed
           p=exp(-(y-mean)*(y-mean)/2.0/sigma/sigma)
11      continue
        gauss0=y
        return
        end

        function ipoisson(mu,seed)
c       chooses a number from a Poisson probability distribution
c       given randomising function  rnd(seed)

        integer*4 ipoisson,seed
        real*4    mu,sigma,p
        sigmax=4

c       ==== a gaussian approximation suffices and is easier for
c                              large values of  mu:
        if (mu.ge.20) then
            ipoisson=nint(gauss(mu,sqrt(mu*1.0),seed))
            return
            end if

c       ==== a genuine Poisson distribution ========
        sigma=sqrt(mu*1.0)
        z=1.0
        p=0.0
        do 71 while(z.gt.p)
            x=rnd(seed)
            y=int(x *( mu+ sigmax*sigma))
            z=rnd(seed)
c           ---- assign  p= mu^y exp(-mu) / y!
            p=exp(-1.0*mu)
            do 75 i=1,y
               p=p*mu /(float(i))
75         continue
        if (p.gt.1.0) write(6,*)'ERROR: Poisson prob. = ',p
71      continue

        ipoisson=y
        return
        end

c     --- a wrapper function for other random generators ---
      real*4 function rnd(seed)
      integer*4 seed  ! as of astromisc-0.1.1 seed is *not* used

C     INTERNAL:
      integer   ifirst
      save      ifirst

      real*8    ran8

      if(ifirst.ne.12345)then
         ifirst=12345
         call ran_op()
      endif

      ran8= rangsl()
      rnd=real(ran8)

      return
      end



c     randt() can be any random number generator
c     A standard source for a GPL random number generator is 
c     http://random.mat.sbg.ac.at/ftp/pub/software/gen/
c     or
c     http://statistik.wu-wien.ac.at/prng/
c     
c     A variation on version 3.0 of prng is  prng-3.0-f77wrap
c     which includes a simple  randt()  fortran wrapper.
c
c     Or just use GSL (GNU Scientific Library).
